.section .text,"ax"
.cpu cortex-m3
.thumb
.syntax unified

#include "globals.h"

.global asm_test_fault
.global reset_user_stack
.global switch_to_user_mode
.global switch_to_supervisor_mode
.global switch_mode
.global change_ret
.extern user_stack DATA				// this adress can be read like: ldr Rx, =user_stack

reset_user_stack:
	ldr r0, =user_stack
	mov r1, USER_STACK_SIZE
	lsl r1, r1, #2			// (e.g. multiply by word size == 4 bytes)
	add r0, r1
	msr PSP, r0
	mov r2, #3
	msr CONTROL, r2
	bx  lr

switch_mode:
	mrs r1, control
	mov r1, r0
	msr control, r1
	bx lr

/*************************/
// R0: user_starting_address
/*************************/
change_ret:
	mrs r1, PSP
	str r0, [r1, #24]
	msr PSP, r1
	bx 	lr

.equ bad_addr,0x90000

.thumb_func
asm_test_fault:
	ldr r0,=bad_addr
	ldr r1,[r0]				// mem access error
	mov r2,#2
	mov r3,#3
	nop
	bx  lr


.ltorg
