/*
 * macro.h
 *
 *  Created on: 20 Dec 2023
 *      Author: iliya
 */

#ifndef MACRO_H_
#define MACRO_H_

#define SUPERVISOR_CONTROL_VALUE 0
#define USER_CONTROL_VALUE 3

// Region enable bit
#define REGION_ENABLE (0x1 << 0)

// Memory region sizes
#define SET_SIZE_512KB (0x12 << 1)
#define SET_SIZE_32KB (0xE << 1)
#define SET_SIZE_16KB (0xD << 1)

// Access permission attribute
#define BTEX_NORMAL_NOT_SHAREABLE (0x1 << 19)
#define BTEX_NOT_SHAREABLE_DEVICE (0x2 << 19)

// Access permission field
#define RO (0x7 << 24)
#define RW (0x3 << 24)
#define RW_PRIV (0x1 << 24)
#define RW_PRIV_R_UNPRIV (0x2 << 24)

#endif /* MACRO_H_ */
