/*
 * user_cmd.h
 *
 *  Created on: 12 nov. 2023
 *  Author: VP
 */
#ifndef USER_CMD_H_
#define USER_CMD_H_
#include <string.h>
#include "uart.h"

#define UART_STDOUT_SIZE 100
#define USER_INPUT_SIZE 200

static char uart_stdout[UART_STDOUT_SIZE] = { 0 };

#define UART_ENABLE 0		// if 0, the console is MCUXpresso, otherwise the UART (use a terminal on PC side)

#define uart_printf(...) \
	snprintf(uart_stdout, UART_STDOUT_SIZE, __VA_ARGS__); \
	uart0_send_ref((uint8_t *)uart_stdout, UART_STDOUT_SIZE); \
	memset(uart_stdout, 0, UART_STDOUT_SIZE);

#if UART_ENABLE
#define PRINT uart_printf
#else
#define PRINT printf
#endif

void uart_scanf(char *buff);

void exec_user_read_write(void);

#endif /* USER_CMD_H_ */
